<template>
  <a-modal
    centered
    class="expenseTypeEdit-modal"
    :footer="null"
    :maskClosable="false"
    :title="modalTit"
    v-model="isShow"
    @cancle="isShow=false"
    :width="800">
    <a-spin :spinning="spinning" tip="Loading...">
      <!-- 表单 -->
      <div>
        <a-form-model
          id="expenseTypeEdit-form"
          ref="ruleForm"
          :model="form"
          :rules="rules"
          :label-col="formItemLayout.labelCol"
          :wrapper-col="formItemLayout.wrapperCol"
        >
          <a-form-model-item label="所属类别" v-if="parentType">
            {{ parentType }}
          </a-form-model-item>
          <a-form-model-item label="费用类型名称" prop="name">
            <a-input
              v-model.trim="form.name"
              @change="filterEmpty"
              id="expenseTypeEdit-name"
              :maxLength="30"
              allowClear
              placeholder="请输入费用类型名称(最多30个字符)" />
          </a-form-model-item>
        </a-form-model>
        <div class="btn-cont">
          <a-button type="primary" id="product-category-edit-modal-save" @click="handleSave">保存</a-button>
          <a-button id="product-category-edit-modal-back" @click="isShow = false" style="margin-left: 15px;">返回列表</a-button>
        </div>
      </div>
    </a-spin>
  </a-modal>
</template>

<script>
import { commonMixin } from '@/utils/mixin'
import { STable } from '@/components'
import { costTypeSave } from '@/api/costType'
export default {
  name: 'ExpenseTypeEditModal',
  components: { STable },
  mixins: [commonMixin],
  props: {
    openModal: { //  弹框显示状态
      type: Boolean,
      default: false
    },
    itemId: {
      type: [Number, String],
      default: ''
    },
    nowData: {
      type: Object,
      default: null
    }
  },
  computed: {
    modalTit () {
      return (this.itemId ? '编辑' : '新增') + '费用类型'
    }
  },
  data () {
    return {
      spinning: false,
      isShow: this.openModal, //  是否打开弹框
      formItemLayout: {
        labelCol: { span: 6 },
        wrapperCol: { span: 16 }
      },
      form: {
        name: '' // 费用类型名称
      },
      rules: {
        name: [
          { required: true, message: '请输入费用类型名称', trigger: 'blur' }
        ]
      },
      parentType: '' //  父级分类
    }
  },
  methods: {
    filterEmpty () {
      let str = this.form.name
      str = str.replace(/\ +/g, '')
      str = str.replace(/[ ]/g, '')
      str = str.replace(/[\r\n]/g, '')
      str = str.replace(/[,，]/g, '')
      this.form.name = str
    },
    //  保存
    handleSave () {
      const _this = this
      _this.$refs.ruleForm.validate(valid => {
        if (valid) {
          const formData = JSON.parse(JSON.stringify(_this.form))
          formData.id = _this.itemId ? _this.itemId : undefined
          formData.psn = _this.nowData && _this.nowData.psn ? _this.nowData.psn : undefined
          _this.spinning = true
          costTypeSave(formData).then(res => {
            if (res.status == 200) {
              _this.$message.success(res.message)
              _this.$emit('ok')
              _this.isShow = false
              _this.spinning = false
            } else {
              _this.spinning = false
            }
          })
        } else {
          return false
        }
      })
    }
  },
  watch: {
    //  父页面传过来的弹框状态
    openModal (newValue, oldValue) {
      this.isShow = newValue
    },
    //  重定义的弹框状态
    isShow (newValue, oldValue) {
      if (!newValue) {
        this.$emit('close')
        this.$refs.ruleForm.resetFields()
      } else {
        //  获取父级分类 名称
        if (this.nowData) {
          this.parentType = (this.nowData.namePaths ? (this.nowData.namePaths.replace(/,/g, '>') + '>') : '') + this.nowData.name
        } else {
          this.parentType = ''
        }
      }
    },
    itemId (newValue, oldValue) {
      if (this.isShow && newValue) {
        this.form.name = this.nowData && this.nowData.name ? this.nowData.name : ''
      } else {
        this.form.name = ''
      }
    }
  }
}
</script>

<style lang="less">
  .expenseTypeEdit-modal{
    .ant-modal-body {
    	padding: 40px 40px 24px;
    }
    .btn-cont {
    	text-align: center;
    	margin: 35px 0 10px;
    }
  }
</style>
